import{s as Va,f as Ya,n as Ja,o as Ka}from"../chunks/scheduler.37c15a92.js";import{S as Qa,i as Xa,g as n,s as l,r as Xt,m as r,H as d,A as Za,h as i,f as a,c as p,j as w,u as Zt,x as m,n as c,B as b,k as N,y as o,a as e,v as ta,d as aa,t as sa,w as ea}from"../chunks/index.7cb9c9b8.js";import{H as na}from"../chunks/Heading.d3928e2a.js";function ts(ua){let u,st,Z,et,P,nt,L,fa="Don’t worry. <strong>It’s normal if this seems complex to handle right now</strong>. But we’re going to see what this Clipped Surrogate Objective Function looks like, and this will help you to visualize better what’s going on.",it,y,va=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,lt,$,da="We have six different situations. Remember first that we take the minimum between the clipped and unclipped objectives.",pt,H,mt,x,ia,V,wa="the clipping does not apply since the ratio is between the range",ot,Aa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',rt,z,ba="In situation 1, we have a positive advantage: the <strong>action is better than the average</strong> of all the actions in that state. Therefore, we should encourage our current policy to increase the probability of taking that action in that state.",ct,I,ya="Since the ratio is between intervals, <strong>we can increase our policy’s probability of taking that action at that state.</strong>",ht,j,xa="In situation 2, we have a negative advantage: the action is worse than the average of all actions at that state. Therefore, we should discourage our current policy from taking that action in that state.",gt,O,_a="Since the ratio is between intervals, <strong>we can decrease the probability that our policy takes that action at that state.</strong>",ut,S,ft,_,ka=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,vt,k,la,dt,Ba='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',wt,bt,q,Ca="If, like in situation 3, the advantage estimate is positive (A&gt;0), then <strong>you want to increase the probability of taking that action at that state.</strong>",yt,E,Ma="But if, like situation 4, the advantage estimate is negative, <strong>we don’t want to decrease further</strong> the probability of taking that action at that state. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",xt,A,_t,C,Ta=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,kt,f,pa,Ct,Da='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Mt,Y,Pa="much higher than in the former policy.",Tt,B,La="If, like in situation 5, the advantage is positive, <strong>we don’t want to get too greedy</strong>. We already have a higher probability of taking that action at that state than the former policy. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",Pt,D,$a="If, like in situation 6, the advantage is negative, we want to decrease the probability of taking that action at that state.",Lt,R,Ha="So if we recap, <strong>we only update the policy with the unclipped objective part</strong>. When the minimum is the clipped objective part, we don’t update our policy weights since the gradient will equal 0.",$t,G,za="So we update our policy  only if:",Ht,M,J,ma,zt,Ra='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',oa,K,Ia="Our ratio is outside the range, but <strong>the advantage leads to getting closer to the range</strong><ul><li>Being below the ratio but the advantage is &gt; 0</li> <li>Being above the ratio but the advantage is &lt; 0</li></ul>",It,h,Q,ja="You might wonder why, when the minimum is the clipped ratio, the gradient is 0.",ra,jt,Ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> r_t(\\theta) * A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ot,St,Fa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 - \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',qt,Et,Ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 + \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',At,Bt,g,ca,X,Oa="we restrict the range that the current policy can vary from the old one.",ha,Dt,Wa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>+</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 + \\epsilon </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Rt,Gt,Na='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>−</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 - \\epsilon </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Ft,Ut,F,Sa="The final Clipped Surrogate Objective Loss for PPO Actor-Critic style looks like this, it’s a combination of Clipped Surrogate Objective function, Value Loss Function and Entropy bonus:",Wt,U,qa,Nt,W,Ea='That was quite complex. Take time to understand these situations by looking at the table and the graph. <strong>You must understand why this makes sense.</strong> If you want to go deeper, the best resource is the article <a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf" rel="nofollow">Towards Delivering a Coherent Self-Contained Explanation of Proximal Policy Optimization” by Daniel Bick, especially part 3.4</a>.',Vt,tt,Yt;return P=new na({props:{title:"Visualize the Clipped Surrogate Objective Function",local:"visualize-the-clipped-surrogate-objective-function",headingTag:"h1"}}),H=new na({props:{title:"Case 1 and 2: the ratio is between the range",local:"case-1-and-2-the-ratio-is-between-the-range",headingTag:"h2"}}),S=new na({props:{title:"Case 3 and 4: the ratio is below the range",local:"case-3-and-4-the-ratio-is-below-the-range",headingTag:"h2"}}),A=new na({props:{title:"Case 5 and 6: the ratio is above the range",local:"case-5-and-6-the-ratio-is-above-the-range",headingTag:"h2"}}),{c(){u=n("meta"),st=l(),Z=n("p"),et=l(),Xt(P.$$.fragment),nt=l(),L=n("p"),L.innerHTML=fa,it=l(),y=n("figure"),y.innerHTML=va,lt=l(),$=n("p"),$.textContent=da,pt=l(),Xt(H.$$.fragment),mt=l(),x=n("p"),ia=r("In situations 1 and 2, "),V=n("strong"),V.textContent=wa,ot=new d(!1),rt=l(),z=n("p"),z.innerHTML=ba,ct=l(),I=n("p"),I.innerHTML=ya,ht=l(),j=n("p"),j.textContent=xa,gt=l(),O=n("p"),O.innerHTML=_a,ut=l(),Xt(S.$$.fragment),ft=l(),_=n("figure"),_.innerHTML=ka,vt=l(),k=n("p"),la=r("If the probability ratio is lower than"),dt=new d(!1),wt=r(", the probability of taking that action at that state is much lower than with the old policy."),bt=l(),q=n("p"),q.innerHTML=Ca,yt=l(),E=n("p"),E.innerHTML=Ma,xt=l(),Xt(A.$$.fragment),_t=l(),C=n("figure"),C.innerHTML=Ta,kt=l(),f=n("p"),pa=r("If the probability ratio is higher than"),Ct=new d(!1),Mt=r(", the probability of taking that action at that state in the current policy is "),Y=n("strong"),Y.textContent=Pa,Tt=l(),B=n("p"),B.innerHTML=La,Pt=l(),D=n("p"),D.textContent=$a,Lt=l(),R=n("p"),R.innerHTML=Ha,$t=l(),G=n("p"),G.textContent=za,Ht=l(),M=n("ul"),J=n("li"),ma=r("Our ratio is in the range"),zt=new d(!1),oa=l(),K=n("li"),K.innerHTML=Ia,It=l(),h=n("p"),Q=n("strong"),Q.textContent=ja,ra=r(" When the ratio is clipped, the derivative in this case will not be the derivative of the"),jt=new d(!1),Ot=r("   but the derivative of either"),St=new d(!1),qt=r(" or the derivative of"),Et=new d(!1),At=r(" which both = 0."),Bt=l(),g=n("p"),ca=r("To summarize, thanks to this clipped surrogate objective, "),X=n("strong"),X.textContent=Oa,ha=r(" Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is >"),Dt=new d(!1),Rt=r(" or <"),Gt=new d(!1),Ft=r(" the gradient will be equal to 0."),Ut=l(),F=n("p"),F.textContent=Sa,Wt=l(),U=n("img"),Nt=l(),W=n("p"),W.innerHTML=Ea,Vt=l(),tt=n("p"),this.h()},l(t){const s=Za("svelte-u9bgzb",document.head);u=i(s,"META",{name:!0,content:!0}),s.forEach(a),st=p(t),Z=i(t,"P",{}),w(Z).forEach(a),et=p(t),Zt(P.$$.fragment,t),nt=p(t),L=i(t,"P",{"data-svelte-h":!0}),m(L)!=="svelte-8fcaqu"&&(L.innerHTML=fa),it=p(t),y=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(y)!=="svelte-1kvrq9v"&&(y.innerHTML=va),lt=p(t),$=i(t,"P",{"data-svelte-h":!0}),m($)!=="svelte-kt354t"&&($.textContent=da),pt=p(t),Zt(H.$$.fragment,t),mt=p(t),x=i(t,"P",{});var Jt=w(x);ia=c(Jt,"In situations 1 and 2, "),V=i(Jt,"STRONG",{"data-svelte-h":!0}),m(V)!=="svelte-w52w77"&&(V.textContent=wa),ot=b(Jt,!1),Jt.forEach(a),rt=p(t),z=i(t,"P",{"data-svelte-h":!0}),m(z)!=="svelte-1cqqr4g"&&(z.innerHTML=ba),ct=p(t),I=i(t,"P",{"data-svelte-h":!0}),m(I)!=="svelte-jfeco7"&&(I.innerHTML=ya),ht=p(t),j=i(t,"P",{"data-svelte-h":!0}),m(j)!=="svelte-uloelw"&&(j.textContent=xa),gt=p(t),O=i(t,"P",{"data-svelte-h":!0}),m(O)!=="svelte-1ffs0w0"&&(O.innerHTML=_a),ut=p(t),Zt(S.$$.fragment,t),ft=p(t),_=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(_)!=="svelte-1kvrq9v"&&(_.innerHTML=ka),vt=p(t),k=i(t,"P",{});var Kt=w(k);la=c(Kt,"If the probability ratio is lower than"),dt=b(Kt,!1),wt=c(Kt,", the probability of taking that action at that state is much lower than with the old policy."),Kt.forEach(a),bt=p(t),q=i(t,"P",{"data-svelte-h":!0}),m(q)!=="svelte-1x6bxjm"&&(q.innerHTML=Ca),yt=p(t),E=i(t,"P",{"data-svelte-h":!0}),m(E)!=="svelte-1l49ylb"&&(E.innerHTML=Ma),xt=p(t),Zt(A.$$.fragment,t),_t=p(t),C=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(C)!=="svelte-1kvrq9v"&&(C.innerHTML=Ta),kt=p(t),f=i(t,"P",{});var at=w(f);pa=c(at,"If the probability ratio is higher than"),Ct=b(at,!1),Mt=c(at,", the probability of taking that action at that state in the current policy is "),Y=i(at,"STRONG",{"data-svelte-h":!0}),m(Y)!=="svelte-qu8nx6"&&(Y.textContent=Pa),at.forEach(a),Tt=p(t),B=i(t,"P",{"data-svelte-h":!0}),m(B)!=="svelte-1ptdkag"&&(B.innerHTML=La),Pt=p(t),D=i(t,"P",{"data-svelte-h":!0}),m(D)!=="svelte-yugfug"&&(D.textContent=$a),Lt=p(t),R=i(t,"P",{"data-svelte-h":!0}),m(R)!=="svelte-1eb9ayw"&&(R.innerHTML=Ha),$t=p(t),G=i(t,"P",{"data-svelte-h":!0}),m(G)!=="svelte-pg5tgk"&&(G.textContent=za),Ht=p(t),M=i(t,"UL",{});var Qt=w(M);J=i(Qt,"LI",{});var ga=w(J);ma=c(ga,"Our ratio is in the range"),zt=b(ga,!1),ga.forEach(a),oa=p(Qt),K=i(Qt,"LI",{"data-svelte-h":!0}),m(K)!=="svelte-1hd4gm6"&&(K.innerHTML=Ia),Qt.forEach(a),It=p(t),h=i(t,"P",{});var v=w(h);Q=i(v,"STRONG",{"data-svelte-h":!0}),m(Q)!=="svelte-xl5clc"&&(Q.textContent=ja),ra=c(v," When the ratio is clipped, the derivative in this case will not be the derivative of the"),jt=b(v,!1),Ot=c(v,"   but the derivative of either"),St=b(v,!1),qt=c(v," or the derivative of"),Et=b(v,!1),At=c(v," which both = 0."),v.forEach(a),Bt=p(t),g=i(t,"P",{});var T=w(g);ca=c(T,"To summarize, thanks to this clipped surrogate objective, "),X=i(T,"STRONG",{"data-svelte-h":!0}),m(X)!=="svelte-vpub9x"&&(X.textContent=Oa),ha=c(T," Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is >"),Dt=b(T,!1),Rt=c(T," or <"),Gt=b(T,!1),Ft=c(T," the gradient will be equal to 0."),T.forEach(a),Ut=p(t),F=i(t,"P",{"data-svelte-h":!0}),m(F)!=="svelte-d7ieux"&&(F.textContent=Sa),Wt=p(t),U=i(t,"IMG",{src:!0,alt:!0}),Nt=p(t),W=i(t,"P",{"data-svelte-h":!0}),m(W)!=="svelte-256dgf"&&(W.innerHTML=Ea),Vt=p(t),tt=i(t,"P",{}),w(tt).forEach(a),this.h()},h(){N(u,"name","hf:doc:metadata"),N(u,"content",as),N(y,"class","image table text-center m-0 w-full"),ot.a=null,N(_,"class","image table text-center m-0 w-full"),dt.a=wt,N(C,"class","image table text-center m-0 w-full"),Ct.a=Mt,zt.a=null,jt.a=Ot,St.a=qt,Et.a=At,Dt.a=Rt,Gt.a=Ft,Ya(U.src,qa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-objective.jpg")||N(U,"src",qa),N(U,"alt","PPO objective")},m(t,s){o(document.head,u),e(t,st,s),e(t,Z,s),e(t,et,s),ta(P,t,s),e(t,nt,s),e(t,L,s),e(t,it,s),e(t,y,s),e(t,lt,s),e(t,$,s),e(t,pt,s),ta(H,t,s),e(t,mt,s),e(t,x,s),o(x,ia),o(x,V),ot.m(Aa,x),e(t,rt,s),e(t,z,s),e(t,ct,s),e(t,I,s),e(t,ht,s),e(t,j,s),e(t,gt,s),e(t,O,s),e(t,ut,s),ta(S,t,s),e(t,ft,s),e(t,_,s),e(t,vt,s),e(t,k,s),o(k,la),dt.m(Ba,k),o(k,wt),e(t,bt,s),e(t,q,s),e(t,yt,s),e(t,E,s),e(t,xt,s),ta(A,t,s),e(t,_t,s),e(t,C,s),e(t,kt,s),e(t,f,s),o(f,pa),Ct.m(Da,f),o(f,Mt),o(f,Y),e(t,Tt,s),e(t,B,s),e(t,Pt,s),e(t,D,s),e(t,Lt,s),e(t,R,s),e(t,$t,s),e(t,G,s),e(t,Ht,s),e(t,M,s),o(M,J),o(J,ma),zt.m(Ra,J),o(M,oa),o(M,K),e(t,It,s),e(t,h,s),o(h,Q),o(h,ra),jt.m(Ga,h),o(h,Ot),St.m(Fa,h),o(h,qt),Et.m(Ua,h),o(h,At),e(t,Bt,s),e(t,g,s),o(g,ca),o(g,X),o(g,ha),Dt.m(Wa,g),o(g,Rt),Gt.m(Na,g),o(g,Ft),e(t,Ut,s),e(t,F,s),e(t,Wt,s),e(t,U,s),e(t,Nt,s),e(t,W,s),e(t,Vt,s),e(t,tt,s),Yt=!0},p:Ja,i(t){Yt||(aa(P.$$.fragment,t),aa(H.$$.fragment,t),aa(S.$$.fragment,t),aa(A.$$.fragment,t),Yt=!0)},o(t){sa(P.$$.fragment,t),sa(H.$$.fragment,t),sa(S.$$.fragment,t),sa(A.$$.fragment,t),Yt=!1},d(t){t&&(a(st),a(Z),a(et),a(nt),a(L),a(it),a(y),a(lt),a($),a(pt),a(mt),a(x),a(rt),a(z),a(ct),a(I),a(ht),a(j),a(gt),a(O),a(ut),a(ft),a(_),a(vt),a(k),a(bt),a(q),a(yt),a(E),a(xt),a(_t),a(C),a(kt),a(f),a(Tt),a(B),a(Pt),a(D),a(Lt),a(R),a($t),a(G),a(Ht),a(M),a(It),a(h),a(Bt),a(g),a(Ut),a(F),a(Wt),a(U),a(Nt),a(W),a(Vt),a(tt)),a(u),ea(P,t),ea(H,t),ea(S,t),ea(A,t)}}}const as='{"title":"Visualize the Clipped Surrogate Objective Function","local":"visualize-the-clipped-surrogate-objective-function","sections":[{"title":"Case 1 and 2: the ratio is between the range","local":"case-1-and-2-the-ratio-is-between-the-range","sections":[],"depth":2},{"title":"Case 3 and 4: the ratio is below the range","local":"case-3-and-4-the-ratio-is-below-the-range","sections":[],"depth":2},{"title":"Case 5 and 6: the ratio is above the range","local":"case-5-and-6-the-ratio-is-above-the-range","sections":[],"depth":2}],"depth":1}';function ss(ua){return Ka(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ls extends Qa{constructor(u){super(),Xa(this,u,ss,ts,Va,{})}}export{ls as component};
